/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file GCClient_AssemblyInfo.hpp
/// User-defined methods of the data storage class.
///
/// This file was originally generated by application DATATOOL
/// using the following specifications:
/// 'gencoll_client.asn'.
///
/// New methods or data members can be added to it if needed.
/// See also: GCClient_AssemblyInfo_.hpp


#ifndef OBJECTS_GENOMECOLL_GCCLIENT_ASSEMBLYINFO_HPP
#define OBJECTS_GENOMECOLL_GCCLIENT_ASSEMBLYINFO_HPP


// generated includes
#include <objects/genomecoll/GCClient_AssemblyInfo_.hpp>

// generated classes

BEGIN_NCBI_SCOPE

BEGIN_objects_SCOPE // namespace ncbi::objects::

/////////////////////////////////////////////////////////////////////////////
class CGCClient_AssemblyInfo : public CGCClient_AssemblyInfo_Base
{
    typedef CGCClient_AssemblyInfo_Base Tparent;
public:
    // constructor
    CGCClient_AssemblyInfo(void);
    // destructor
    ~CGCClient_AssemblyInfo(void);

private:
    // Prohibit copy constructor and assignment operator
    CGCClient_AssemblyInfo(const CGCClient_AssemblyInfo& value);
    CGCClient_AssemblyInfo& operator=(const CGCClient_AssemblyInfo& value);

};

/////////////////// CGCClient_AssemblyInfo inline methods

// constructor
inline
CGCClient_AssemblyInfo::CGCClient_AssemblyInfo(void)
{
}


/////////////////// end of CGCClient_AssemblyInfo inline methods


END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE


#endif // OBJECTS_GENOMECOLL_GCCLIENT_ASSEMBLYINFO_HPP
/* Original file checksum: lines: 86, chars: 2643, CRC32: 148dd19 */
