/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file CDD_Error_.hpp
/// Data storage class.
///
/// This file was generated by application DATATOOL
/// using the following specifications:
/// 'cdd_access.asn'.
///
/// ATTENTION:
///   Don't edit or commit this file into CVS as this file will
///   be overridden (by DATATOOL) without warning!

#ifndef OBJTOOLS_DATA_LOADERS_CDD_CDD_ACCESS_CDD_ERROR_BASE_HPP
#define OBJTOOLS_DATA_LOADERS_CDD_CDD_ACCESS_CDD_ERROR_BASE_HPP

// standard includes
#include <serial/serialbase.hpp>

// generated includes
#include <string>

BEGIN_NCBI_SCOPE

#ifndef BEGIN_objects_SCOPE
#  define BEGIN_objects_SCOPE BEGIN_SCOPE(objects)
#  define END_objects_SCOPE END_SCOPE(objects)
#endif
BEGIN_objects_SCOPE // namespace ncbi::objects::


// generated classes

/////////////////////////////////////////////////////////////////////////////
/// Error reply
class NCBI_CDD_ACCESS_EXPORT CCDD_Error_Base : public CSerialObject
{
    typedef CSerialObject Tparent;
public:
    // constructor
    CCDD_Error_Base(void);
    // destructor
    virtual ~CCDD_Error_Base(void);

    // type info
    DECLARE_INTERNAL_TYPE_INFO();

    enum ESeverity {
        eSeverity_trace    = 0,
        eSeverity_info     = 1,
        eSeverity_warning  = 2,
        eSeverity_error    = 3,
        eSeverity_critical = 4,
        eSeverity_fatal    = 5
    };
    
    /// Access to ESeverity's attributes (values, names) as defined in spec
    static const NCBI_NS_NCBI::CEnumeratedTypeValues* ENUM_METHOD_NAME(ESeverity)(void);
    
    // types
    typedef CStringUTF8 TMessage;
    typedef int TCode;
    typedef int TSeverity;

    // member index
    enum class E_memberIndex {
        e__allMandatory = 0,
        e_message,
        e_code,
        e_severity
    };
    typedef Tparent::CMemberIndex<E_memberIndex, 4> TmemberIndex;

    // getters
    // setters

    /// mandatory
    /// typedef CStringUTF8 TMessage
    ///  Check whether the Message data member has been assigned a value.
    bool IsSetMessage(void) const;
    /// Check whether it is safe or not to call GetMessage method.
    bool CanGetMessage(void) const;
    void ResetMessage(void);
    const TMessage& GetMessage(void) const;
    void SetMessage(const TMessage& value);
    void SetMessage(TMessage&& value);
    TMessage& SetMessage(void);

    /// mandatory
    /// typedef int TCode
    ///  Check whether the Code data member has been assigned a value.
    bool IsSetCode(void) const;
    /// Check whether it is safe or not to call GetCode method.
    bool CanGetCode(void) const;
    void ResetCode(void);
    TCode GetCode(void) const;
    void SetCode(TCode value);
    TCode& SetCode(void);

    /// mandatory
    /// typedef int TSeverity
    ///  Check whether the Severity data member has been assigned a value.
    bool IsSetSeverity(void) const;
    /// Check whether it is safe or not to call GetSeverity method.
    bool CanGetSeverity(void) const;
    void ResetSeverity(void);
    TSeverity GetSeverity(void) const;
    void SetSeverity(TSeverity value);
    TSeverity& SetSeverity(void);

    /// Reset the whole object
    virtual void Reset(void);


private:
    // Prohibit copy constructor and assignment operator
    CCDD_Error_Base(const CCDD_Error_Base&);
    CCDD_Error_Base& operator=(const CCDD_Error_Base&);

    // data
    Uint4 m_set_State[1];
    CStringUTF8 m_Message;
    int m_Code;
    int m_Severity;
};






///////////////////////////////////////////////////////////
///////////////////// inline methods //////////////////////
///////////////////////////////////////////////////////////
inline
bool CCDD_Error_Base::IsSetMessage(void) const
{
    return ((m_set_State[0] & 0x3) != 0);
}

inline
bool CCDD_Error_Base::CanGetMessage(void) const
{
    return IsSetMessage();
}

inline
const CCDD_Error_Base::TMessage& CCDD_Error_Base::GetMessage(void) const
{
    if (!CanGetMessage()) {
        ThrowUnassigned(0);
    }
    return m_Message;
}

inline
void CCDD_Error_Base::SetMessage(const CCDD_Error_Base::TMessage& value)
{
    m_Message = value;
    m_set_State[0] |= 0x3;
}

inline
void CCDD_Error_Base::SetMessage(CCDD_Error_Base::TMessage&& value)
{
    m_Message = std::forward<CCDD_Error_Base::TMessage>(value);
    m_set_State[0] |= 0x3;
}

inline
CCDD_Error_Base::TMessage& CCDD_Error_Base::SetMessage(void)
{
#ifdef _DEBUG
    if (!IsSetMessage()) {
        m_Message = UnassignedStringUTF8();
    }
#endif
    m_set_State[0] |= 0x1;
    return m_Message;
}

inline
bool CCDD_Error_Base::IsSetCode(void) const
{
    return ((m_set_State[0] & 0xc) != 0);
}

inline
bool CCDD_Error_Base::CanGetCode(void) const
{
    return IsSetCode();
}

inline
void CCDD_Error_Base::ResetCode(void)
{
    m_Code = 0;
    m_set_State[0] &= ~0xc;
}

inline
CCDD_Error_Base::TCode CCDD_Error_Base::GetCode(void) const
{
    if (!CanGetCode()) {
        ThrowUnassigned(1);
    }
    return m_Code;
}

inline
void CCDD_Error_Base::SetCode(CCDD_Error_Base::TCode value)
{
    m_Code = value;
    m_set_State[0] |= 0xc;
}

inline
CCDD_Error_Base::TCode& CCDD_Error_Base::SetCode(void)
{
#ifdef _DEBUG
    if (!IsSetCode()) {
        memset(&m_Code,UnassignedByte(),sizeof(m_Code));
    }
#endif
    m_set_State[0] |= 0x4;
    return m_Code;
}

inline
bool CCDD_Error_Base::IsSetSeverity(void) const
{
    return ((m_set_State[0] & 0x30) != 0);
}

inline
bool CCDD_Error_Base::CanGetSeverity(void) const
{
    return IsSetSeverity();
}

inline
void CCDD_Error_Base::ResetSeverity(void)
{
    m_Severity = (ESeverity)(0);
    m_set_State[0] &= ~0x30;
}

inline
CCDD_Error_Base::TSeverity CCDD_Error_Base::GetSeverity(void) const
{
    if (!CanGetSeverity()) {
        ThrowUnassigned(2);
    }
    return m_Severity;
}

inline
void CCDD_Error_Base::SetSeverity(CCDD_Error_Base::TSeverity value)
{
    m_Severity = value;
    m_set_State[0] |= 0x30;
}

inline
CCDD_Error_Base::TSeverity& CCDD_Error_Base::SetSeverity(void)
{
#ifdef _DEBUG
    if (!IsSetSeverity()) {
        memset(&m_Severity,UnassignedByte(),sizeof(m_Severity));
    }
#endif
    m_set_State[0] |= 0x10;
    return m_Severity;
}

///////////////////////////////////////////////////////////
////////////////// end of inline methods //////////////////
///////////////////////////////////////////////////////////





END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE


#endif // OBJTOOLS_DATA_LOADERS_CDD_CDD_ACCESS_CDD_ERROR_BASE_HPP
