/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file CDD_Feat_type_.hpp
/// Data storage class.
///
/// This file was generated by application DATATOOL
/// using the following specifications:
/// 'cdd_access.asn'.
///
/// ATTENTION:
///   Don't edit or commit this file into CVS as this file will
///   be overridden (by DATATOOL) without warning!

#ifndef OBJTOOLS_DATA_LOADERS_CDD_CDD_ACCESS_CDD_FEAT_TYPE_BASE_HPP
#define OBJTOOLS_DATA_LOADERS_CDD_CDD_ACCESS_CDD_FEAT_TYPE_BASE_HPP

// standard includes
#include <serial/serialbase.hpp>
BEGIN_NCBI_SCOPE

#ifndef BEGIN_objects_SCOPE
#  define BEGIN_objects_SCOPE BEGIN_SCOPE(objects)
#  define END_objects_SCOPE END_SCOPE(objects)
#endif
BEGIN_objects_SCOPE // namespace ncbi::objects::


// generated classes

/////////////////////////////////////////////////////////////////////////////
class NCBI_CDD_ACCESS_EXPORT CCDD_Feat_type_Base : public CSerialObject
{
    typedef CSerialObject Tparent;
public:
    // constructor
    CCDD_Feat_type_Base(void);
    // destructor
    virtual ~CCDD_Feat_type_Base(void);

    // type info
    DECLARE_INTERNAL_TYPE_INFO();

    // types
    typedef int TType;
    typedef int TSubtype;

    // member index
    enum class E_memberIndex {
        e__allMandatory = 0,
        e_type,
        e_subtype
    };
    typedef Tparent::CMemberIndex<E_memberIndex, 3> TmemberIndex;

    // getters
    // setters

    /// mandatory
    /// typedef int TType
    ///  Check whether the Type data member has been assigned a value.
    bool IsSetType(void) const;
    /// Check whether it is safe or not to call GetType method.
    bool CanGetType(void) const;
    void ResetType(void);
    TType GetType(void) const;
    void SetType(TType value);
    TType& SetType(void);

    /// optional
    /// typedef int TSubtype
    ///  Check whether the Subtype data member has been assigned a value.
    bool IsSetSubtype(void) const;
    /// Check whether it is safe or not to call GetSubtype method.
    bool CanGetSubtype(void) const;
    void ResetSubtype(void);
    TSubtype GetSubtype(void) const;
    void SetSubtype(TSubtype value);
    TSubtype& SetSubtype(void);

    /// Reset the whole object
    virtual void Reset(void);


private:
    // Prohibit copy constructor and assignment operator
    CCDD_Feat_type_Base(const CCDD_Feat_type_Base&);
    CCDD_Feat_type_Base& operator=(const CCDD_Feat_type_Base&);

    // data
    Uint4 m_set_State[1];
    int m_Type;
    int m_Subtype;
};






///////////////////////////////////////////////////////////
///////////////////// inline methods //////////////////////
///////////////////////////////////////////////////////////
inline
bool CCDD_Feat_type_Base::IsSetType(void) const
{
    return ((m_set_State[0] & 0x3) != 0);
}

inline
bool CCDD_Feat_type_Base::CanGetType(void) const
{
    return IsSetType();
}

inline
void CCDD_Feat_type_Base::ResetType(void)
{
    m_Type = 0;
    m_set_State[0] &= ~0x3;
}

inline
CCDD_Feat_type_Base::TType CCDD_Feat_type_Base::GetType(void) const
{
    if (!CanGetType()) {
        ThrowUnassigned(0);
    }
    return m_Type;
}

inline
void CCDD_Feat_type_Base::SetType(CCDD_Feat_type_Base::TType value)
{
    m_Type = value;
    m_set_State[0] |= 0x3;
}

inline
CCDD_Feat_type_Base::TType& CCDD_Feat_type_Base::SetType(void)
{
#ifdef _DEBUG
    if (!IsSetType()) {
        memset(&m_Type,UnassignedByte(),sizeof(m_Type));
    }
#endif
    m_set_State[0] |= 0x1;
    return m_Type;
}

inline
bool CCDD_Feat_type_Base::IsSetSubtype(void) const
{
    return ((m_set_State[0] & 0xc) != 0);
}

inline
bool CCDD_Feat_type_Base::CanGetSubtype(void) const
{
    return IsSetSubtype();
}

inline
void CCDD_Feat_type_Base::ResetSubtype(void)
{
    m_Subtype = 0;
    m_set_State[0] &= ~0xc;
}

inline
CCDD_Feat_type_Base::TSubtype CCDD_Feat_type_Base::GetSubtype(void) const
{
    if (!CanGetSubtype()) {
        ThrowUnassigned(1);
    }
    return m_Subtype;
}

inline
void CCDD_Feat_type_Base::SetSubtype(CCDD_Feat_type_Base::TSubtype value)
{
    m_Subtype = value;
    m_set_State[0] |= 0xc;
}

inline
CCDD_Feat_type_Base::TSubtype& CCDD_Feat_type_Base::SetSubtype(void)
{
#ifdef _DEBUG
    if (!IsSetSubtype()) {
        memset(&m_Subtype,UnassignedByte(),sizeof(m_Subtype));
    }
#endif
    m_set_State[0] |= 0x4;
    return m_Subtype;
}

///////////////////////////////////////////////////////////
////////////////// end of inline methods //////////////////
///////////////////////////////////////////////////////////





END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE


#endif // OBJTOOLS_DATA_LOADERS_CDD_CDD_ACCESS_CDD_FEAT_TYPE_BASE_HPP
