/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file CDD_Rep_Get_Blob_By_Seq_Id_.hpp
/// Data storage class.
///
/// This file was generated by application DATATOOL
/// using the following specifications:
/// 'cdd_access.asn'.
///
/// ATTENTION:
///   Don't edit or commit this file into CVS as this file will
///   be overridden (by DATATOOL) without warning!

#ifndef OBJTOOLS_DATA_LOADERS_CDD_CDD_ACCESS_CDD_REP_GET_BLOB_BY_SEQ_ID_BASE_HPP
#define OBJTOOLS_DATA_LOADERS_CDD_CDD_ACCESS_CDD_REP_GET_BLOB_BY_SEQ_ID_BASE_HPP

// standard includes
#include <serial/serialbase.hpp>
BEGIN_NCBI_SCOPE

#ifndef BEGIN_objects_SCOPE
#  define BEGIN_objects_SCOPE BEGIN_SCOPE(objects)
#  define END_objects_SCOPE END_SCOPE(objects)
#endif
BEGIN_objects_SCOPE // namespace ncbi::objects::


// forward declarations
class CCDD_Reply_Get_Blob_Id;
class CSeq_annot;


// generated classes

/////////////////////////////////////////////////////////////////////////////
/// Reply to the get-blob-by-seq-id request.
/// Reply is a composite of get-blob-id + get-blob replies.
class NCBI_CDD_ACCESS_EXPORT CCDD_Reply_Get_Blob_By_Seq_Id_Base : public CSerialObject
{
    typedef CSerialObject Tparent;
public:
    // constructor
    CCDD_Reply_Get_Blob_By_Seq_Id_Base(void);
    // destructor
    virtual ~CCDD_Reply_Get_Blob_By_Seq_Id_Base(void);

    // type info
    DECLARE_INTERNAL_TYPE_INFO();

    // types
    typedef CSeq_annot TBlob;
    typedef CCDD_Reply_Get_Blob_Id TBlob_id;

    // member index
    enum class E_memberIndex {
        e__allMandatory = 0,
        e_blob,
        e_blob_id
    };
    typedef Tparent::CMemberIndex<E_memberIndex, 3> TmemberIndex;

    // getters
    // setters

    /// return Seq-annot (like a get-blob request)
    /// mandatory
    /// typedef CSeq_annot TBlob
    ///  Check whether the Blob data member has been assigned a value.
    bool IsSetBlob(void) const;
    /// Check whether it is safe or not to call GetBlob method.
    bool CanGetBlob(void) const;
    void ResetBlob(void);
    const TBlob& GetBlob(void) const;
    void SetBlob(TBlob& value);
    TBlob& SetBlob(void);

    /// return blob-id (like a get-blob-id request)
    /// mandatory
    /// typedef CCDD_Reply_Get_Blob_Id TBlob_id
    ///  Check whether the Blob_id data member has been assigned a value.
    bool IsSetBlob_id(void) const;
    /// Check whether it is safe or not to call GetBlob_id method.
    bool CanGetBlob_id(void) const;
    void ResetBlob_id(void);
    const TBlob_id& GetBlob_id(void) const;
    void SetBlob_id(TBlob_id& value);
    TBlob_id& SetBlob_id(void);

    /// Reset the whole object
    virtual void Reset(void);


private:
    // Prohibit copy constructor and assignment operator
    CCDD_Reply_Get_Blob_By_Seq_Id_Base(const CCDD_Reply_Get_Blob_By_Seq_Id_Base&);
    CCDD_Reply_Get_Blob_By_Seq_Id_Base& operator=(const CCDD_Reply_Get_Blob_By_Seq_Id_Base&);

    // data
    Uint4 m_set_State[1];
    CRef< TBlob > m_Blob;
    CRef< TBlob_id > m_Blob_id;
};






///////////////////////////////////////////////////////////
///////////////////// inline methods //////////////////////
///////////////////////////////////////////////////////////
inline
bool CCDD_Reply_Get_Blob_By_Seq_Id_Base::IsSetBlob(void) const
{
    return m_Blob.NotEmpty();
}

inline
bool CCDD_Reply_Get_Blob_By_Seq_Id_Base::CanGetBlob(void) const
{
    return true;
}

inline
const CCDD_Reply_Get_Blob_By_Seq_Id_Base::TBlob& CCDD_Reply_Get_Blob_By_Seq_Id_Base::GetBlob(void) const
{
    if ( !m_Blob ) {
        const_cast<CCDD_Reply_Get_Blob_By_Seq_Id_Base*>(this)->ResetBlob();
    }
    return (*m_Blob);
}

inline
CCDD_Reply_Get_Blob_By_Seq_Id_Base::TBlob& CCDD_Reply_Get_Blob_By_Seq_Id_Base::SetBlob(void)
{
    if ( !m_Blob ) {
        ResetBlob();
    }
    return (*m_Blob);
}

inline
bool CCDD_Reply_Get_Blob_By_Seq_Id_Base::IsSetBlob_id(void) const
{
    return m_Blob_id.NotEmpty();
}

inline
bool CCDD_Reply_Get_Blob_By_Seq_Id_Base::CanGetBlob_id(void) const
{
    return true;
}

inline
const CCDD_Reply_Get_Blob_By_Seq_Id_Base::TBlob_id& CCDD_Reply_Get_Blob_By_Seq_Id_Base::GetBlob_id(void) const
{
    if ( !m_Blob_id ) {
        const_cast<CCDD_Reply_Get_Blob_By_Seq_Id_Base*>(this)->ResetBlob_id();
    }
    return (*m_Blob_id);
}

inline
CCDD_Reply_Get_Blob_By_Seq_Id_Base::TBlob_id& CCDD_Reply_Get_Blob_By_Seq_Id_Base::SetBlob_id(void)
{
    if ( !m_Blob_id ) {
        ResetBlob_id();
    }
    return (*m_Blob_id);
}

///////////////////////////////////////////////////////////
////////////////// end of inline methods //////////////////
///////////////////////////////////////////////////////////





END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE


#endif // OBJTOOLS_DATA_LOADERS_CDD_CDD_ACCESS_CDD_REP_GET_BLOB_BY_SEQ_ID_BASE_HPP
