/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file CDD_Reply_.hpp
/// Data storage class.
///
/// This file was generated by application DATATOOL
/// using the following specifications:
/// 'cdd_access.asn'.
///
/// ATTENTION:
///   Don't edit or commit this file into CVS as this file will
///   be overridden (by DATATOOL) without warning!

#ifndef OBJTOOLS_DATA_LOADERS_CDD_CDD_ACCESS_CDD_REPLY_BASE_HPP
#define OBJTOOLS_DATA_LOADERS_CDD_CDD_ACCESS_CDD_REPLY_BASE_HPP

// standard includes
#include <serial/serialbase.hpp>
BEGIN_NCBI_SCOPE

#ifndef BEGIN_objects_SCOPE
#  define BEGIN_objects_SCOPE BEGIN_SCOPE(objects)
#  define END_objects_SCOPE END_SCOPE(objects)
#endif
BEGIN_objects_SCOPE // namespace ncbi::objects::


// forward declarations
class CCDD_Error;
class CCDD_Reply_Get_Blob_By_Seq_Id;
class CCDD_Reply_Get_Blob_Id;
class CSeq_annot;


// generated classes

/////////////////////////////////////////////////////////////////////////////
///*********************************************************************
/// reply types
///*********************************************************************
/// Replies are sent one-by-one, each reply contains serial number from
/// the original request. Replies for a packet of requests may be sent
/// in any order, the last reply must have end-of-reply flag set.
/// If the flag is set before sending all replies, any pending requests
/// should be discarded.
/// Error reply may be sent for a single request or for the whole packet
/// (or all remaining requests from the packet) - in this case the error
/// reply must have end-of-reply flag set.
class NCBI_CDD_ACCESS_EXPORT CCDD_Reply_Base : public CSerialObject
{
    typedef CSerialObject Tparent;
public:
    // constructor
    CCDD_Reply_Base(void);
    // destructor
    virtual ~CCDD_Reply_Base(void);

    // type info
    DECLARE_INTERNAL_TYPE_INFO();

    /////////////////////////////////////////////////////////////////////////////
    class NCBI_CDD_ACCESS_EXPORT C_Reply : public CSerialObject
    {
        typedef CSerialObject Tparent;
    public:
        // constructor
        C_Reply(void);
        // destructor
        ~C_Reply(void);
    
        // type info
        DECLARE_INTERNAL_TYPE_INFO();
    
    
        /// Choice variants.
        enum E_Choice {
            e_not_set = 0,         ///< No variant selected
            e_Empty,               ///< no data found for the request
            e_Get_blob_id,         ///< return blob-id for get-blob-id request
            e_Get_blob,            ///< return Seq-annot for get-blob request
            e_Get_blob_by_seq_id   ///< return (Seq-annot + blob-id) for get-blob-by-seq-id OR get-blob-by-seq-ids request
        };
        /// Maximum+1 value of the choice variant enumerator.
        enum E_ChoiceStopper {
            e_MaxChoice = 5 ///< == e_Get_blob_by_seq_id+1
        };
    
        /// Reset the whole object
        void Reset(void);
    
        /// Reset the selection (set it to e_not_set).
        void ResetSelection(void);
    
        /// Which variant is currently selected.
        E_Choice Which(void) const;
    
        /// Verify selection, throw exception if it differs from the expected.
        void CheckSelected(E_Choice index) const;
    
        /// Throw 'InvalidSelection' exception.
        NCBI_NORETURN void ThrowInvalidSelection(E_Choice index) const;
    
        /// Retrieve selection name (for diagnostic purposes).
        static string SelectionName(E_Choice index);
    
        /// Select the requested variant if needed.
        void Select(E_Choice index, EResetVariant reset = eDoResetVariant);
        /// Select the requested variant if needed,
        /// allocating CObject variants from memory pool.
        void Select(E_Choice index,
                    EResetVariant reset,
                    CObjectMemoryPool* pool);
    
        // types
        typedef CCDD_Reply_Get_Blob_Id TGet_blob_id;
        typedef CSeq_annot TGet_blob;
        typedef CCDD_Reply_Get_Blob_By_Seq_Id TGet_blob_by_seq_id;
    
        // getters
        // setters
    
    
        bool IsEmpty(void) const;
        void SetEmpty(void);
    
        // typedef CCDD_Reply_Get_Blob_Id TGet_blob_id
        bool IsGet_blob_id(void) const;
        const TGet_blob_id& GetGet_blob_id(void) const;
        TGet_blob_id& SetGet_blob_id(void);
        void SetGet_blob_id(TGet_blob_id& value);
    
        // typedef CSeq_annot TGet_blob
        bool IsGet_blob(void) const;
        const TGet_blob& GetGet_blob(void) const;
        TGet_blob& SetGet_blob(void);
        void SetGet_blob(TGet_blob& value);
    
        // typedef CCDD_Reply_Get_Blob_By_Seq_Id TGet_blob_by_seq_id
        bool IsGet_blob_by_seq_id(void) const;
        const TGet_blob_by_seq_id& GetGet_blob_by_seq_id(void) const;
        TGet_blob_by_seq_id& SetGet_blob_by_seq_id(void);
        void SetGet_blob_by_seq_id(TGet_blob_by_seq_id& value);
    
    
    private:
        // copy constructor and assignment operator
        C_Reply(const C_Reply& );
        C_Reply& operator=(const C_Reply& );
        // choice state
        E_Choice m_choice;
        // helper methods
        void DoSelect(E_Choice index, CObjectMemoryPool* pool = 0);
    
        static const char* const sm_SelectionNames[];
        // data
        union {
            NCBI_NS_NCBI::CSerialObject *m_object;
        };
    };
    // types
    typedef int TSerial_number;
    typedef CCDD_Error TError;
    typedef C_Reply TReply;

    // member index
    enum class E_memberIndex {
        e__allMandatory = 0,
        e_serial_number,
        e_error,
        e_end_of_reply,
        e_reply
    };
    typedef Tparent::CMemberIndex<E_memberIndex, 5> TmemberIndex;

    // getters
    // setters

    /// request's serial number, copy from request
    /// optional
    /// typedef int TSerial_number
    ///  Check whether the Serial_number data member has been assigned a value.
    bool IsSetSerial_number(void) const;
    /// Check whether it is safe or not to call GetSerial_number method.
    bool CanGetSerial_number(void) const;
    void ResetSerial_number(void);
    TSerial_number GetSerial_number(void) const;
    void SetSerial_number(TSerial_number value);
    TSerial_number& SetSerial_number(void);

    /// optional
    /// typedef CCDD_Error TError
    ///  Check whether the Error data member has been assigned a value.
    bool IsSetError(void) const;
    /// Check whether it is safe or not to call GetError method.
    bool CanGetError(void) const;
    void ResetError(void);
    const TError& GetError(void) const;
    void SetError(TError& value);
    TError& SetError(void);

    /// true if this reply is the last one for the request
    /// false if more replies will follow
    /// optional
    ///  Check whether the End_of_reply data member has been assigned a value.
    bool IsSetEnd_of_reply(void) const;
    /// Check whether it is safe or not to call GetEnd_of_reply method.
    bool CanGetEnd_of_reply(void) const;
    void ResetEnd_of_reply(void);
    void SetEnd_of_reply(void);

    /// mandatory
    /// typedef C_Reply TReply
    ///  Check whether the Reply data member has been assigned a value.
    bool IsSetReply(void) const;
    /// Check whether it is safe or not to call GetReply method.
    bool CanGetReply(void) const;
    void ResetReply(void);
    const TReply& GetReply(void) const;
    void SetReply(TReply& value);
    TReply& SetReply(void);

    /// Reset the whole object
    virtual void Reset(void);


private:
    // Prohibit copy constructor and assignment operator
    CCDD_Reply_Base(const CCDD_Reply_Base&);
    CCDD_Reply_Base& operator=(const CCDD_Reply_Base&);

    // data
    Uint4 m_set_State[1];
    int m_Serial_number;
    CRef< TError > m_Error;
    CRef< TReply > m_Reply;
};






///////////////////////////////////////////////////////////
///////////////////// inline methods //////////////////////
///////////////////////////////////////////////////////////
inline
CCDD_Reply_Base::C_Reply::E_Choice CCDD_Reply_Base::C_Reply::Which(void) const
{
    return m_choice;
}

inline
void CCDD_Reply_Base::C_Reply::CheckSelected(E_Choice index) const
{
    if ( m_choice != index )
        ThrowInvalidSelection(index);
}

inline
void CCDD_Reply_Base::C_Reply::Select(E_Choice index, NCBI_NS_NCBI::EResetVariant reset, NCBI_NS_NCBI::CObjectMemoryPool* pool)
{
    if ( reset == NCBI_NS_NCBI::eDoResetVariant || m_choice != index ) {
        if ( m_choice != e_not_set )
            ResetSelection();
        DoSelect(index, pool);
    }
}

inline
void CCDD_Reply_Base::C_Reply::Select(E_Choice index, NCBI_NS_NCBI::EResetVariant reset)
{
    Select(index, reset, 0);
}

inline
bool CCDD_Reply_Base::C_Reply::IsEmpty(void) const
{
    return m_choice == e_Empty;
}

inline
void CCDD_Reply_Base::C_Reply::SetEmpty(void)
{
    Select(e_Empty, NCBI_NS_NCBI::eDoNotResetVariant);
}

inline
bool CCDD_Reply_Base::C_Reply::IsGet_blob_id(void) const
{
    return m_choice == e_Get_blob_id;
}

inline
bool CCDD_Reply_Base::C_Reply::IsGet_blob(void) const
{
    return m_choice == e_Get_blob;
}

inline
bool CCDD_Reply_Base::C_Reply::IsGet_blob_by_seq_id(void) const
{
    return m_choice == e_Get_blob_by_seq_id;
}

inline
bool CCDD_Reply_Base::IsSetSerial_number(void) const
{
    return ((m_set_State[0] & 0x3) != 0);
}

inline
bool CCDD_Reply_Base::CanGetSerial_number(void) const
{
    return IsSetSerial_number();
}

inline
void CCDD_Reply_Base::ResetSerial_number(void)
{
    m_Serial_number = 0;
    m_set_State[0] &= ~0x3;
}

inline
CCDD_Reply_Base::TSerial_number CCDD_Reply_Base::GetSerial_number(void) const
{
    if (!CanGetSerial_number()) {
        ThrowUnassigned(0);
    }
    return m_Serial_number;
}

inline
void CCDD_Reply_Base::SetSerial_number(CCDD_Reply_Base::TSerial_number value)
{
    m_Serial_number = value;
    m_set_State[0] |= 0x3;
}

inline
CCDD_Reply_Base::TSerial_number& CCDD_Reply_Base::SetSerial_number(void)
{
#ifdef _DEBUG
    if (!IsSetSerial_number()) {
        memset(&m_Serial_number,UnassignedByte(),sizeof(m_Serial_number));
    }
#endif
    m_set_State[0] |= 0x1;
    return m_Serial_number;
}

inline
bool CCDD_Reply_Base::IsSetError(void) const
{
    return m_Error.NotEmpty();
}

inline
bool CCDD_Reply_Base::CanGetError(void) const
{
    return IsSetError();
}

inline
const CCDD_Reply_Base::TError& CCDD_Reply_Base::GetError(void) const
{
    if (!CanGetError()) {
        ThrowUnassigned(1);
    }
    return (*m_Error);
}

inline
bool CCDD_Reply_Base::IsSetEnd_of_reply(void) const
{
    return ((m_set_State[0] & 0x30) != 0);
}

inline
bool CCDD_Reply_Base::CanGetEnd_of_reply(void) const
{
    return false;
}

inline
void CCDD_Reply_Base::ResetEnd_of_reply(void)
{
    m_set_State[0] &= ~0x30;
}

inline
void CCDD_Reply_Base::SetEnd_of_reply(void)
{
    m_set_State[0] |= 0x30;
}

inline
bool CCDD_Reply_Base::IsSetReply(void) const
{
    return m_Reply.NotEmpty();
}

inline
bool CCDD_Reply_Base::CanGetReply(void) const
{
    return true;
}

inline
const CCDD_Reply_Base::TReply& CCDD_Reply_Base::GetReply(void) const
{
    if ( !m_Reply ) {
        const_cast<CCDD_Reply_Base*>(this)->ResetReply();
    }
    return (*m_Reply);
}

inline
CCDD_Reply_Base::TReply& CCDD_Reply_Base::SetReply(void)
{
    if ( !m_Reply ) {
        ResetReply();
    }
    return (*m_Reply);
}

///////////////////////////////////////////////////////////
////////////////// end of inline methods //////////////////
///////////////////////////////////////////////////////////





END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE


#endif // OBJTOOLS_DATA_LOADERS_CDD_CDD_ACCESS_CDD_REPLY_BASE_HPP
