/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file CDD_Reply_Get_Blob_Id_.hpp
/// Data storage class.
///
/// This file was generated by application DATATOOL
/// using the following specifications:
/// 'cdd_access.asn'.
///
/// ATTENTION:
///   Don't edit or commit this file into CVS as this file will
///   be overridden (by DATATOOL) without warning!

#ifndef OBJTOOLS_DATA_LOADERS_CDD_CDD_ACCESS_CDD_REPLY_GET_BLOB_ID_BASE_HPP
#define OBJTOOLS_DATA_LOADERS_CDD_CDD_ACCESS_CDD_REPLY_GET_BLOB_ID_BASE_HPP

// standard includes
#include <serial/serialbase.hpp>

// generated includes
#include <list>

BEGIN_NCBI_SCOPE

#ifndef BEGIN_objects_SCOPE
#  define BEGIN_objects_SCOPE BEGIN_SCOPE(objects)
#  define END_objects_SCOPE END_SCOPE(objects)
#endif
BEGIN_objects_SCOPE // namespace ncbi::objects::


// forward declarations
class CCDD_Feat_type;
class CID2_Blob_Id;
class CSeq_id;


// generated classes

/////////////////////////////////////////////////////////////////////////////
/// Reply to get-blob-id request.
class NCBI_CDD_ACCESS_EXPORT CCDD_Reply_Get_Blob_Id_Base : public CSerialObject
{
    typedef CSerialObject Tparent;
public:
    // constructor
    CCDD_Reply_Get_Blob_Id_Base(void);
    // destructor
    virtual ~CCDD_Reply_Get_Blob_Id_Base(void);

    // type info
    DECLARE_INTERNAL_TYPE_INFO();

    // types
    typedef CSeq_id TSeq_id;
    typedef CID2_Blob_Id TBlob_id;
    typedef list< CRef< CCDD_Feat_type > > TFeat_types;

    // member index
    enum class E_memberIndex {
        e__allMandatory = 0,
        e_seq_id,
        e_blob_id,
        e_feat_types
    };
    typedef Tparent::CMemberIndex<E_memberIndex, 4> TmemberIndex;

    // getters
    // setters

    /// seq-id used in the CDD annotation
    /// mandatory
    /// typedef CSeq_id TSeq_id
    ///  Check whether the Seq_id data member has been assigned a value.
    bool IsSetSeq_id(void) const;
    /// Check whether it is safe or not to call GetSeq_id method.
    bool CanGetSeq_id(void) const;
    void ResetSeq_id(void);
    const TSeq_id& GetSeq_id(void) const;
    void SetSeq_id(TSeq_id& value);
    TSeq_id& SetSeq_id(void);

    /// resulting blob-id
    /// mandatory
    /// typedef CID2_Blob_Id TBlob_id
    ///  Check whether the Blob_id data member has been assigned a value.
    bool IsSetBlob_id(void) const;
    /// Check whether it is safe or not to call GetBlob_id method.
    bool CanGetBlob_id(void) const;
    void ResetBlob_id(void);
    const TBlob_id& GetBlob_id(void) const;
    void SetBlob_id(TBlob_id& value);
    TBlob_id& SetBlob_id(void);

    /// types and subtypes of features in the blob
    /// optional
    /// typedef list< CRef< CCDD_Feat_type > > TFeat_types
    ///  Check whether the Feat_types data member has been assigned a value.
    bool IsSetFeat_types(void) const;
    /// Check whether it is safe or not to call GetFeat_types method.
    bool CanGetFeat_types(void) const;
    void ResetFeat_types(void);
    const TFeat_types& GetFeat_types(void) const;
    TFeat_types& SetFeat_types(void);

    /// Reset the whole object
    virtual void Reset(void);


private:
    // Prohibit copy constructor and assignment operator
    CCDD_Reply_Get_Blob_Id_Base(const CCDD_Reply_Get_Blob_Id_Base&);
    CCDD_Reply_Get_Blob_Id_Base& operator=(const CCDD_Reply_Get_Blob_Id_Base&);

    // data
    Uint4 m_set_State[1];
    CRef< TSeq_id > m_Seq_id;
    CRef< TBlob_id > m_Blob_id;
    list< CRef< CCDD_Feat_type > > m_Feat_types;
};






///////////////////////////////////////////////////////////
///////////////////// inline methods //////////////////////
///////////////////////////////////////////////////////////
inline
bool CCDD_Reply_Get_Blob_Id_Base::IsSetSeq_id(void) const
{
    return m_Seq_id.NotEmpty();
}

inline
bool CCDD_Reply_Get_Blob_Id_Base::CanGetSeq_id(void) const
{
    return true;
}

inline
const CCDD_Reply_Get_Blob_Id_Base::TSeq_id& CCDD_Reply_Get_Blob_Id_Base::GetSeq_id(void) const
{
    if ( !m_Seq_id ) {
        const_cast<CCDD_Reply_Get_Blob_Id_Base*>(this)->ResetSeq_id();
    }
    return (*m_Seq_id);
}

inline
CCDD_Reply_Get_Blob_Id_Base::TSeq_id& CCDD_Reply_Get_Blob_Id_Base::SetSeq_id(void)
{
    if ( !m_Seq_id ) {
        ResetSeq_id();
    }
    return (*m_Seq_id);
}

inline
bool CCDD_Reply_Get_Blob_Id_Base::IsSetBlob_id(void) const
{
    return m_Blob_id.NotEmpty();
}

inline
bool CCDD_Reply_Get_Blob_Id_Base::CanGetBlob_id(void) const
{
    return true;
}

inline
const CCDD_Reply_Get_Blob_Id_Base::TBlob_id& CCDD_Reply_Get_Blob_Id_Base::GetBlob_id(void) const
{
    if ( !m_Blob_id ) {
        const_cast<CCDD_Reply_Get_Blob_Id_Base*>(this)->ResetBlob_id();
    }
    return (*m_Blob_id);
}

inline
CCDD_Reply_Get_Blob_Id_Base::TBlob_id& CCDD_Reply_Get_Blob_Id_Base::SetBlob_id(void)
{
    if ( !m_Blob_id ) {
        ResetBlob_id();
    }
    return (*m_Blob_id);
}

inline
bool CCDD_Reply_Get_Blob_Id_Base::IsSetFeat_types(void) const
{
    return ((m_set_State[0] & 0x30) != 0);
}

inline
bool CCDD_Reply_Get_Blob_Id_Base::CanGetFeat_types(void) const
{
    return true;
}

inline
const CCDD_Reply_Get_Blob_Id_Base::TFeat_types& CCDD_Reply_Get_Blob_Id_Base::GetFeat_types(void) const
{
    return m_Feat_types;
}

inline
CCDD_Reply_Get_Blob_Id_Base::TFeat_types& CCDD_Reply_Get_Blob_Id_Base::SetFeat_types(void)
{
    m_set_State[0] |= 0x10;
    return m_Feat_types;
}

///////////////////////////////////////////////////////////
////////////////// end of inline methods //////////////////
///////////////////////////////////////////////////////////





END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE


#endif // OBJTOOLS_DATA_LOADERS_CDD_CDD_ACCESS_CDD_REPLY_GET_BLOB_ID_BASE_HPP
