/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file CDD_Request_.hpp
/// Data storage class.
///
/// This file was generated by application DATATOOL
/// using the following specifications:
/// 'cdd_access.asn'.
///
/// ATTENTION:
///   Don't edit or commit this file into CVS as this file will
///   be overridden (by DATATOOL) without warning!

#ifndef OBJTOOLS_DATA_LOADERS_CDD_CDD_ACCESS_CDD_REQUEST_BASE_HPP
#define OBJTOOLS_DATA_LOADERS_CDD_CDD_ACCESS_CDD_REQUEST_BASE_HPP

// standard includes
#include <serial/serialbase.hpp>

// generated includes
#include <list>

BEGIN_NCBI_SCOPE

#ifndef BEGIN_objects_SCOPE
#  define BEGIN_objects_SCOPE BEGIN_SCOPE(objects)
#  define END_objects_SCOPE END_SCOPE(objects)
#endif
BEGIN_objects_SCOPE // namespace ncbi::objects::


// forward declarations
class CID2_Blob_Id;
class CSeq_id;


// generated classes

/////////////////////////////////////////////////////////////////////////////
class NCBI_CDD_ACCESS_EXPORT CCDD_Request_Base : public CSerialObject
{
    typedef CSerialObject Tparent;
public:
    // constructor
    CCDD_Request_Base(void);
    // destructor
    virtual ~CCDD_Request_Base(void);

    // type info
    DECLARE_INTERNAL_TYPE_INFO();

    /////////////////////////////////////////////////////////////////////////////
    class NCBI_CDD_ACCESS_EXPORT C_Request : public CSerialObject
    {
        typedef CSerialObject Tparent;
    public:
        // constructor
        C_Request(void);
        // destructor
        ~C_Request(void);
    
        // type info
        DECLARE_INTERNAL_TYPE_INFO();
    
    
        /// Choice variants.
        enum E_Choice {
            e_not_set = 0,          ///< No variant selected
            e_Get_blob_id,          ///< get blob-id for the seq-id
            e_Get_blob,             ///< get data for the blob-id
            e_Get_blob_by_seq_id,   ///< get one blob for one seq-id
            e_Get_blob_by_seq_ids   ///< get one blob for multiple seq-ids
        };
        /// Maximum+1 value of the choice variant enumerator.
        enum E_ChoiceStopper {
            e_MaxChoice = 5 ///< == e_Get_blob_by_seq_ids+1
        };
    
        /// Reset the whole object
        void Reset(void);
    
        /// Reset the selection (set it to e_not_set).
        void ResetSelection(void);
    
        /// Which variant is currently selected.
        E_Choice Which(void) const;
    
        /// Verify selection, throw exception if it differs from the expected.
        void CheckSelected(E_Choice index) const;
    
        /// Throw 'InvalidSelection' exception.
        NCBI_NORETURN void ThrowInvalidSelection(E_Choice index) const;
    
        /// Retrieve selection name (for diagnostic purposes).
        static string SelectionName(E_Choice index);
    
        /// Select the requested variant if needed.
        void Select(E_Choice index, EResetVariant reset = eDoResetVariant);
        /// Select the requested variant if needed,
        /// allocating CObject variants from memory pool.
        void Select(E_Choice index,
                    EResetVariant reset,
                    CObjectMemoryPool* pool);
    
        // types
        typedef CSeq_id TGet_blob_id;
        typedef CID2_Blob_Id TGet_blob;
        typedef CSeq_id TGet_blob_by_seq_id;
        typedef list< CRef< CSeq_id > > TGet_blob_by_seq_ids;
    
        // getters
        // setters
    
        // typedef CSeq_id TGet_blob_id
        bool IsGet_blob_id(void) const;
        const TGet_blob_id& GetGet_blob_id(void) const;
        TGet_blob_id& SetGet_blob_id(void);
        void SetGet_blob_id(TGet_blob_id& value);
    
        // typedef CID2_Blob_Id TGet_blob
        bool IsGet_blob(void) const;
        const TGet_blob& GetGet_blob(void) const;
        TGet_blob& SetGet_blob(void);
        void SetGet_blob(TGet_blob& value);
    
        // typedef CSeq_id TGet_blob_by_seq_id
        bool IsGet_blob_by_seq_id(void) const;
        const TGet_blob_by_seq_id& GetGet_blob_by_seq_id(void) const;
        TGet_blob_by_seq_id& SetGet_blob_by_seq_id(void);
        void SetGet_blob_by_seq_id(TGet_blob_by_seq_id& value);
    
        // typedef list< CRef< CSeq_id > > TGet_blob_by_seq_ids
        bool IsGet_blob_by_seq_ids(void) const;
        const TGet_blob_by_seq_ids& GetGet_blob_by_seq_ids(void) const;
        TGet_blob_by_seq_ids& SetGet_blob_by_seq_ids(void);
    
    
    private:
        // copy constructor and assignment operator
        C_Request(const C_Request& );
        C_Request& operator=(const C_Request& );
        // choice state
        E_Choice m_choice;
        // helper methods
        void DoSelect(E_Choice index, CObjectMemoryPool* pool = 0);
    
        static const char* const sm_SelectionNames[];
        // data
        union {
            NCBI_NS_NCBI::CUnionBuffer<TGet_blob_by_seq_ids> m_Get_blob_by_seq_ids;
            NCBI_NS_NCBI::CSerialObject *m_object;
        };
    };
    // types
    typedef int TSerial_number;
    typedef C_Request TRequest;

    // member index
    enum class E_memberIndex {
        e__allMandatory = 0,
        e_serial_number,
        e_request
    };
    typedef Tparent::CMemberIndex<E_memberIndex, 3> TmemberIndex;

    // getters
    // setters

    /// request's serial number, can be used in asynchronous clients
    /// server should copy it to corresponding field in reply
    /// optional
    /// typedef int TSerial_number
    ///  Check whether the Serial_number data member has been assigned a value.
    bool IsSetSerial_number(void) const;
    /// Check whether it is safe or not to call GetSerial_number method.
    bool CanGetSerial_number(void) const;
    void ResetSerial_number(void);
    TSerial_number GetSerial_number(void) const;
    void SetSerial_number(TSerial_number value);
    TSerial_number& SetSerial_number(void);

    /// mandatory
    /// typedef C_Request TRequest
    ///  Check whether the Request data member has been assigned a value.
    bool IsSetRequest(void) const;
    /// Check whether it is safe or not to call GetRequest method.
    bool CanGetRequest(void) const;
    void ResetRequest(void);
    const TRequest& GetRequest(void) const;
    void SetRequest(TRequest& value);
    TRequest& SetRequest(void);

    /// Reset the whole object
    virtual void Reset(void);


private:
    // Prohibit copy constructor and assignment operator
    CCDD_Request_Base(const CCDD_Request_Base&);
    CCDD_Request_Base& operator=(const CCDD_Request_Base&);

    // data
    Uint4 m_set_State[1];
    int m_Serial_number;
    CRef< TRequest > m_Request;
};






///////////////////////////////////////////////////////////
///////////////////// inline methods //////////////////////
///////////////////////////////////////////////////////////
inline
CCDD_Request_Base::C_Request::E_Choice CCDD_Request_Base::C_Request::Which(void) const
{
    return m_choice;
}

inline
void CCDD_Request_Base::C_Request::CheckSelected(E_Choice index) const
{
    if ( m_choice != index )
        ThrowInvalidSelection(index);
}

inline
void CCDD_Request_Base::C_Request::Select(E_Choice index, NCBI_NS_NCBI::EResetVariant reset, NCBI_NS_NCBI::CObjectMemoryPool* pool)
{
    if ( reset == NCBI_NS_NCBI::eDoResetVariant || m_choice != index ) {
        if ( m_choice != e_not_set )
            ResetSelection();
        DoSelect(index, pool);
    }
}

inline
void CCDD_Request_Base::C_Request::Select(E_Choice index, NCBI_NS_NCBI::EResetVariant reset)
{
    Select(index, reset, 0);
}

inline
bool CCDD_Request_Base::C_Request::IsGet_blob_id(void) const
{
    return m_choice == e_Get_blob_id;
}

inline
bool CCDD_Request_Base::C_Request::IsGet_blob(void) const
{
    return m_choice == e_Get_blob;
}

inline
bool CCDD_Request_Base::C_Request::IsGet_blob_by_seq_id(void) const
{
    return m_choice == e_Get_blob_by_seq_id;
}

inline
bool CCDD_Request_Base::C_Request::IsGet_blob_by_seq_ids(void) const
{
    return m_choice == e_Get_blob_by_seq_ids;
}

inline
const CCDD_Request_Base::C_Request::TGet_blob_by_seq_ids& CCDD_Request_Base::C_Request::GetGet_blob_by_seq_ids(void) const
{
    CheckSelected(e_Get_blob_by_seq_ids);
    return *m_Get_blob_by_seq_ids;
}

inline
CCDD_Request_Base::C_Request::TGet_blob_by_seq_ids& CCDD_Request_Base::C_Request::SetGet_blob_by_seq_ids(void)
{
    Select(e_Get_blob_by_seq_ids, NCBI_NS_NCBI::eDoNotResetVariant);
    return *m_Get_blob_by_seq_ids;
}

inline
bool CCDD_Request_Base::IsSetSerial_number(void) const
{
    return ((m_set_State[0] & 0x3) != 0);
}

inline
bool CCDD_Request_Base::CanGetSerial_number(void) const
{
    return IsSetSerial_number();
}

inline
void CCDD_Request_Base::ResetSerial_number(void)
{
    m_Serial_number = 0;
    m_set_State[0] &= ~0x3;
}

inline
CCDD_Request_Base::TSerial_number CCDD_Request_Base::GetSerial_number(void) const
{
    if (!CanGetSerial_number()) {
        ThrowUnassigned(0);
    }
    return m_Serial_number;
}

inline
void CCDD_Request_Base::SetSerial_number(CCDD_Request_Base::TSerial_number value)
{
    m_Serial_number = value;
    m_set_State[0] |= 0x3;
}

inline
CCDD_Request_Base::TSerial_number& CCDD_Request_Base::SetSerial_number(void)
{
#ifdef _DEBUG
    if (!IsSetSerial_number()) {
        memset(&m_Serial_number,UnassignedByte(),sizeof(m_Serial_number));
    }
#endif
    m_set_State[0] |= 0x1;
    return m_Serial_number;
}

inline
bool CCDD_Request_Base::IsSetRequest(void) const
{
    return m_Request.NotEmpty();
}

inline
bool CCDD_Request_Base::CanGetRequest(void) const
{
    return true;
}

inline
const CCDD_Request_Base::TRequest& CCDD_Request_Base::GetRequest(void) const
{
    if ( !m_Request ) {
        const_cast<CCDD_Request_Base*>(this)->ResetRequest();
    }
    return (*m_Request);
}

inline
CCDD_Request_Base::TRequest& CCDD_Request_Base::SetRequest(void)
{
    if ( !m_Request ) {
        ResetRequest();
    }
    return (*m_Request);
}

///////////////////////////////////////////////////////////
////////////////// end of inline methods //////////////////
///////////////////////////////////////////////////////////





END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE


#endif // OBJTOOLS_DATA_LOADERS_CDD_CDD_ACCESS_CDD_REQUEST_BASE_HPP
