/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file EMyNCBIResult_.hpp
/// Data storage class.
///
/// This file was generated by application DATATOOL
/// using the following specifications:
/// 'eMyNCBI_result.xsd'.
///
/// ATTENTION:
///   Don't edit or commit this file into CVS as this file will
///   be overridden (by DATATOOL) without warning!

#ifndef OBJTOOLS_DATA_LOADERS_GENBANK_PUBSEQ2_EMYNCBIRESULT_BASE_HPP
#define OBJTOOLS_DATA_LOADERS_GENBANK_PUBSEQ2_EMYNCBIRESULT_BASE_HPP

// standard includes
#include <serial/serialbase.hpp>

// generated includes
#include <list>
#include <string>

BEGIN_NCBI_SCOPE

#ifndef BEGIN_objects_SCOPE
#  define BEGIN_objects_SCOPE BEGIN_SCOPE(objects)
#  define END_objects_SCOPE END_SCOPE(objects)
#endif
BEGIN_objects_SCOPE // namespace ncbi::objects::


// generated classes

/////////////////////////////////////////////////////////////////////////////
class CEMyNCBIResult_Base : public CSerialObject
{
    typedef CSerialObject Tparent;
public:
    // constructor
    CEMyNCBIResult_Base(void);
    // destructor
    virtual ~CEMyNCBIResult_Base(void);

    // type info
    DECLARE_INTERNAL_TYPE_INFO();

    /////////////////////////////////////////////////////////////////////////////
    class C_UE : public CSerialObject
    {
        typedef CSerialObject Tparent;
    public:
        // constructor
        C_UE(void);
        // destructor
        ~C_UE(void);
    
        // type info
        DECLARE_INTERNAL_TYPE_INFO();
    
        /////////////////////////////////////////////////////////////////////////////
        class C_UU : public CSerialObject
        {
            typedef CSerialObject Tparent;
        public:
            // constructor
            C_UU(void);
            // destructor
            ~C_UU(void);
        
            // type info
            DECLARE_INTERNAL_TYPE_INFO();
        
            // types
            typedef string TUserId;
            typedef string TUserName;
        
            // member index
            enum class E_memberIndex {
                e__allMandatory = 0,
                e_UserId,
                e_UserName
            };
            typedef Tparent::CMemberIndex<E_memberIndex, 3> TmemberIndex;
        
            // getters
            // setters
        
            /// mandatory
            /// typedef string TUserId
            ///  Check whether the UserId data member has been assigned a value.
            bool IsSetUserId(void) const;
            /// Check whether it is safe or not to call GetUserId method.
            bool CanGetUserId(void) const;
            void ResetUserId(void);
            const TUserId& GetUserId(void) const;
            void SetUserId(const TUserId& value);
            void SetUserId(TUserId&& value);
            TUserId& SetUserId(void);
        
            /// mandatory
            /// typedef string TUserName
            ///  Check whether the UserName data member has been assigned a value.
            bool IsSetUserName(void) const;
            /// Check whether it is safe or not to call GetUserName method.
            bool CanGetUserName(void) const;
            void ResetUserName(void);
            const TUserName& GetUserName(void) const;
            void SetUserName(const TUserName& value);
            void SetUserName(TUserName&& value);
            TUserName& SetUserName(void);
        
            /// Reset the whole object
            void Reset(void);
        
        
        private:
            // Prohibit copy constructor and assignment operator
            C_UU(const C_UU&);
            C_UU& operator=(const C_UU&);
        
            // data
            Uint4 m_set_State[1];
            string m_UserId;
            string m_UserName;
        };
    
        /// Choice variants.
        enum E_Choice {
            e_not_set = 0,  ///< No variant selected
            e_UU,
            e_ERROR
        };
        /// Maximum+1 value of the choice variant enumerator.
        enum E_ChoiceStopper {
            e_MaxChoice = 3 ///< == e_ERROR+1
        };
    
        /// Reset the whole object
        void Reset(void);
    
        /// Reset the selection (set it to e_not_set).
        void ResetSelection(void);
    
        /// Which variant is currently selected.
        E_Choice Which(void) const;
    
        /// Verify selection, throw exception if it differs from the expected.
        void CheckSelected(E_Choice index) const;
    
        /// Throw 'InvalidSelection' exception.
        NCBI_NORETURN void ThrowInvalidSelection(E_Choice index) const;
    
        /// Retrieve selection name (for diagnostic purposes).
        static string SelectionName(E_Choice index);
    
        /// Select the requested variant if needed.
        void Select(E_Choice index, EResetVariant reset = eDoResetVariant);
        /// Select the requested variant if needed,
        /// allocating CObject variants from memory pool.
        void Select(E_Choice index,
                    EResetVariant reset,
                    CObjectMemoryPool* pool);
    
        // types
        typedef C_UU TUU;
        typedef string TERROR;
    
        // getters
        // setters
    
        // typedef C_UU TUU
        bool IsUU(void) const;
        const TUU& GetUU(void) const;
        TUU& SetUU(void);
        void SetUU(TUU& value);
    
        // typedef string TERROR
        bool IsERROR(void) const;
        const TERROR& GetERROR(void) const;
        TERROR& SetERROR(void);
        void SetERROR(const TERROR& value);
    
    
    private:
        // copy constructor and assignment operator
        C_UE(const C_UE& );
        C_UE& operator=(const C_UE& );
        // choice state
        E_Choice m_choice;
        // helper methods
        void DoSelect(E_Choice index, CObjectMemoryPool* pool = 0);
    
        static const char* const sm_SelectionNames[];
        // data
        union {
            NCBI_NS_NCBI::CUnionBuffer<NCBI_NS_STD::string> m_string;
            NCBI_NS_NCBI::CSerialObject *m_object;
        };
    };
    // types
    typedef C_UE TUE;
    typedef list< CRef< CAnyContentObject > > TAnyContent;

    // member index
    enum class E_memberIndex {
        e__allMandatory = 0,
        e_UE,
        e_AnyContent
    };
    typedef Tparent::CMemberIndex<E_memberIndex, 3> TmemberIndex;

    // getters
    // setters

    /// mandatory
    /// typedef C_UE TUE
    ///  Check whether the UE data member has been assigned a value.
    bool IsSetUE(void) const;
    /// Check whether it is safe or not to call GetUE method.
    bool CanGetUE(void) const;
    void ResetUE(void);
    const TUE& GetUE(void) const;
    void SetUE(TUE& value);
    TUE& SetUE(void);

    /// mandatory
    /// typedef list< CRef< CAnyContentObject > > TAnyContent
    ///  Check whether the AnyContent data member has been assigned a value.
    bool IsSetAnyContent(void) const;
    /// Check whether it is safe or not to call GetAnyContent method.
    bool CanGetAnyContent(void) const;
    void ResetAnyContent(void);
    const TAnyContent& GetAnyContent(void) const;
    TAnyContent& SetAnyContent(void);

    /// Reset the whole object
    virtual void Reset(void);


private:
    // Prohibit copy constructor and assignment operator
    CEMyNCBIResult_Base(const CEMyNCBIResult_Base&);
    CEMyNCBIResult_Base& operator=(const CEMyNCBIResult_Base&);

    // data
    Uint4 m_set_State[1];
    CRef< TUE > m_UE;
    list< CRef< CAnyContentObject > > m_AnyContent;
};






///////////////////////////////////////////////////////////
///////////////////// inline methods //////////////////////
///////////////////////////////////////////////////////////
inline
bool CEMyNCBIResult_Base::C_UE::C_UU::IsSetUserId(void) const
{
    return ((m_set_State[0] & 0x3) != 0);
}

inline
bool CEMyNCBIResult_Base::C_UE::C_UU::CanGetUserId(void) const
{
    return IsSetUserId();
}

inline
const CEMyNCBIResult_Base::C_UE::C_UU::TUserId& CEMyNCBIResult_Base::C_UE::C_UU::GetUserId(void) const
{
    if (!CanGetUserId()) {
        ThrowUnassigned(0);
    }
    return m_UserId;
}

inline
void CEMyNCBIResult_Base::C_UE::C_UU::SetUserId(const CEMyNCBIResult_Base::C_UE::C_UU::TUserId& value)
{
    m_UserId = value;
    m_set_State[0] |= 0x3;
}

inline
void CEMyNCBIResult_Base::C_UE::C_UU::SetUserId(CEMyNCBIResult_Base::C_UE::C_UU::TUserId&& value)
{
    m_UserId = std::forward<CEMyNCBIResult_Base::C_UE::C_UU::TUserId>(value);
    m_set_State[0] |= 0x3;
}

inline
CEMyNCBIResult_Base::C_UE::C_UU::TUserId& CEMyNCBIResult_Base::C_UE::C_UU::SetUserId(void)
{
#ifdef _DEBUG
    if (!IsSetUserId()) {
        m_UserId = UnassignedString();
    }
#endif
    m_set_State[0] |= 0x1;
    return m_UserId;
}

inline
bool CEMyNCBIResult_Base::C_UE::C_UU::IsSetUserName(void) const
{
    return ((m_set_State[0] & 0xc) != 0);
}

inline
bool CEMyNCBIResult_Base::C_UE::C_UU::CanGetUserName(void) const
{
    return IsSetUserName();
}

inline
const CEMyNCBIResult_Base::C_UE::C_UU::TUserName& CEMyNCBIResult_Base::C_UE::C_UU::GetUserName(void) const
{
    if (!CanGetUserName()) {
        ThrowUnassigned(1);
    }
    return m_UserName;
}

inline
void CEMyNCBIResult_Base::C_UE::C_UU::SetUserName(const CEMyNCBIResult_Base::C_UE::C_UU::TUserName& value)
{
    m_UserName = value;
    m_set_State[0] |= 0xc;
}

inline
void CEMyNCBIResult_Base::C_UE::C_UU::SetUserName(CEMyNCBIResult_Base::C_UE::C_UU::TUserName&& value)
{
    m_UserName = std::forward<CEMyNCBIResult_Base::C_UE::C_UU::TUserName>(value);
    m_set_State[0] |= 0xc;
}

inline
CEMyNCBIResult_Base::C_UE::C_UU::TUserName& CEMyNCBIResult_Base::C_UE::C_UU::SetUserName(void)
{
#ifdef _DEBUG
    if (!IsSetUserName()) {
        m_UserName = UnassignedString();
    }
#endif
    m_set_State[0] |= 0x4;
    return m_UserName;
}

inline
CEMyNCBIResult_Base::C_UE::E_Choice CEMyNCBIResult_Base::C_UE::Which(void) const
{
    return m_choice;
}

inline
void CEMyNCBIResult_Base::C_UE::CheckSelected(E_Choice index) const
{
    if ( m_choice != index )
        ThrowInvalidSelection(index);
}

inline
void CEMyNCBIResult_Base::C_UE::Select(E_Choice index, NCBI_NS_NCBI::EResetVariant reset, NCBI_NS_NCBI::CObjectMemoryPool* pool)
{
    if ( reset == NCBI_NS_NCBI::eDoResetVariant || m_choice != index ) {
        if ( m_choice != e_not_set )
            ResetSelection();
        DoSelect(index, pool);
    }
}

inline
void CEMyNCBIResult_Base::C_UE::Select(E_Choice index, NCBI_NS_NCBI::EResetVariant reset)
{
    Select(index, reset, 0);
}

inline
bool CEMyNCBIResult_Base::C_UE::IsUU(void) const
{
    return m_choice == e_UU;
}

inline
bool CEMyNCBIResult_Base::C_UE::IsERROR(void) const
{
    return m_choice == e_ERROR;
}

inline
const CEMyNCBIResult_Base::C_UE::TERROR& CEMyNCBIResult_Base::C_UE::GetERROR(void) const
{
    CheckSelected(e_ERROR);
    return *m_string;
}

inline
CEMyNCBIResult_Base::C_UE::TERROR& CEMyNCBIResult_Base::C_UE::SetERROR(void)
{
    Select(e_ERROR, NCBI_NS_NCBI::eDoNotResetVariant);
    return *m_string;
}

inline
bool CEMyNCBIResult_Base::IsSetUE(void) const
{
    return m_UE.NotEmpty();
}

inline
bool CEMyNCBIResult_Base::CanGetUE(void) const
{
    return true;
}

inline
const CEMyNCBIResult_Base::TUE& CEMyNCBIResult_Base::GetUE(void) const
{
    if ( !m_UE ) {
        const_cast<CEMyNCBIResult_Base*>(this)->ResetUE();
    }
    return (*m_UE);
}

inline
CEMyNCBIResult_Base::TUE& CEMyNCBIResult_Base::SetUE(void)
{
    if ( !m_UE ) {
        ResetUE();
    }
    return (*m_UE);
}

inline
bool CEMyNCBIResult_Base::IsSetAnyContent(void) const
{
    return ((m_set_State[0] & 0xc) != 0);
}

inline
bool CEMyNCBIResult_Base::CanGetAnyContent(void) const
{
    return true;
}

inline
const CEMyNCBIResult_Base::TAnyContent& CEMyNCBIResult_Base::GetAnyContent(void) const
{
    return m_AnyContent;
}

inline
CEMyNCBIResult_Base::TAnyContent& CEMyNCBIResult_Base::SetAnyContent(void)
{
    m_set_State[0] |= 0x4;
    return m_AnyContent;
}

///////////////////////////////////////////////////////////
////////////////// end of inline methods //////////////////
///////////////////////////////////////////////////////////





END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE


#endif // OBJTOOLS_DATA_LOADERS_GENBANK_PUBSEQ2_EMYNCBIRESULT_BASE_HPP
