/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file ArticleId.hpp
/// User-defined methods of the data storage class.
///
/// This file was originally generated by application DATATOOL
/// using the following specifications:
/// 'efetch.xsd'.
///
/// New methods or data members can be added to it if needed.
/// See also: ArticleId_.hpp


#ifndef eutils__OBJTOOLS_EUTILS_EFETCH_ARTICLEID_HPP
#define eutils__OBJTOOLS_EUTILS_EFETCH_ARTICLEID_HPP


// generated includes
#include <objtools/eutils/efetch/ArticleId_.hpp>

// generated classes

BEGIN_eutils_SCOPE // namespace eutils::

/////////////////////////////////////////////////////////////////////////////
class CArticleId : public CArticleId_Base
{
    typedef CArticleId_Base Tparent;
public:
    // constructor
    CArticleId(void);
    CArticleId(const std::string& value);
    // destructor
    ~CArticleId(void);

    // typedef std::string TArticleId;

    /// Conversion operator to 'TArticleId' type.
    operator const TArticleId&(void) const;
    /// Assignment operator.
    CArticleId& operator=(const TArticleId& value);

private:
    // Prohibit copy constructor and assignment operator
    CArticleId(const CArticleId& value);
    CArticleId& operator=(const CArticleId& value);

};

/////////////////// CArticleId inline methods

// constructor
inline
CArticleId::CArticleId(void)
{
}

inline
CArticleId::CArticleId(const std::string& value)
{
    SetArticleId(value);
}

inline
CArticleId::operator const CArticleId::TArticleId&(void) const
{
    return GetArticleId();
}

inline
CArticleId& CArticleId::operator=(const TArticleId& value)
{
    SetArticleId(value);
    return *this;
}


/////////////////// end of CArticleId inline methods


END_eutils_SCOPE // namespace eutils::


#endif // eutils__OBJTOOLS_EUTILS_EFETCH_ARTICLEID_HPP
/* Original file checksum: lines: 109, chars: 2934, CRC32: 76b8c23b */
