#include <objtools/eutils/efetch/Abs.hpp>
#include <objtools/eutils/efetch/Abstract.hpp>
#include <objtools/eutils/efetch/AbstractText.hpp>
#include <objtools/eutils/efetch/AccessionNumber.hpp>
#include <objtools/eutils/efetch/AccessionNumberList.hpp>
#include <objtools/eutils/efetch/Acronym.hpp>
#include <objtools/eutils/efetch/Affiliation.hpp>
#include <objtools/eutils/efetch/AffiliationInfo.hpp>
#include <objtools/eutils/efetch/Agency.hpp>
#include <objtools/eutils/efetch/And.hpp>
#include <objtools/eutils/efetch/Annotation.hpp>
#include <objtools/eutils/efetch/Annotation_xml.hpp>
#include <objtools/eutils/efetch/Apply.hpp>
#include <objtools/eutils/efetch/Apply_content.hpp>
#include <objtools/eutils/efetch/Approx.hpp>
#include <objtools/eutils/efetch/Arccos.hpp>
#include <objtools/eutils/efetch/Arccosh.hpp>
#include <objtools/eutils/efetch/Arccot.hpp>
#include <objtools/eutils/efetch/Arccoth.hpp>
#include <objtools/eutils/efetch/Arccsc.hpp>
#include <objtools/eutils/efetch/Arccsch.hpp>
#include <objtools/eutils/efetch/Arcsec.hpp>
#include <objtools/eutils/efetch/Arcsech.hpp>
#include <objtools/eutils/efetch/Arcsin.hpp>
#include <objtools/eutils/efetch/Arcsinh.hpp>
#include <objtools/eutils/efetch/Arctan.hpp>
#include <objtools/eutils/efetch/Arctanh.hpp>
#include <objtools/eutils/efetch/Arg.hpp>
#include <objtools/eutils/efetch/Article.hpp>
#include <objtools/eutils/efetch/ArticleDate.hpp>
#include <objtools/eutils/efetch/ArticleId.hpp>
#include <objtools/eutils/efetch/ArticleIdList.hpp>
#include <objtools/eutils/efetch/ArticleTitle.hpp>
#include <objtools/eutils/efetch/Author.hpp>
#include <objtools/eutils/efetch/AuthorList.hpp>
#include <objtools/eutils/efetch/B.hpp>
#include <objtools/eutils/efetch/BeginningDate.hpp>
#include <objtools/eutils/efetch/Bind.hpp>
#include <objtools/eutils/efetch/Bind_content.hpp>
#include <objtools/eutils/efetch/Book.hpp>
#include <objtools/eutils/efetch/BookDocument.hpp>
#include <objtools/eutils/efetch/BookDocumentSet.hpp>
#include <objtools/eutils/efetch/BookTitle.hpp>
#include <objtools/eutils/efetch/Bvar.hpp>
#include <objtools/eutils/efetch/BvarQ.hpp>
#include <objtools/eutils/efetch/Card.hpp>
#include <objtools/eutils/efetch/Cartesianproduct.hpp>
#include <objtools/eutils/efetch/Cbytes.hpp>
#include <objtools/eutils/efetch/Ceiling.hpp>
#include <objtools/eutils/efetch/Cerror.hpp>
#include <objtools/eutils/efetch/Chemical.hpp>
#include <objtools/eutils/efetch/ChemicalList.hpp>
#include <objtools/eutils/efetch/Ci.hpp>
#include <objtools/eutils/efetch/Ci_content.hpp>
#include <objtools/eutils/efetch/Citation.hpp>
#include <objtools/eutils/efetch/CitationSubset.hpp>
#include <objtools/eutils/efetch/Cn.hpp>
#include <objtools/eutils/efetch/Cn_content.hpp>
#include <objtools/eutils/efetch/Codomain.hpp>
#include <objtools/eutils/efetch/CoiStatement.hpp>
#include <objtools/eutils/efetch/CollectionTitle.hpp>
#include <objtools/eutils/efetch/CollectiveName.hpp>
#include <objtools/eutils/efetch/CommentsCorrections.hpp>
#include <objtools/eutils/efetch/CommentsCorrectionsList.hpp>
#include <objtools/eutils/efetch/Complexes.hpp>
#include <objtools/eutils/efetch/Compose.hpp>
#include <objtools/eutils/efetch/Condition.hpp>
#include <objtools/eutils/efetch/Conjugate.hpp>
#include <objtools/eutils/efetch/ContExp.hpp>
#include <objtools/eutils/efetch/ContractNumber.hpp>
#include <objtools/eutils/efetch/ContributionDate.hpp>
#include <objtools/eutils/efetch/CopyrightInformation.hpp>
#include <objtools/eutils/efetch/Cos.hpp>
#include <objtools/eutils/efetch/Cosh.hpp>
#include <objtools/eutils/efetch/Cot.hpp>
#include <objtools/eutils/efetch/Coth.hpp>
#include <objtools/eutils/efetch/Country.hpp>
#include <objtools/eutils/efetch/Cs.hpp>
#include <objtools/eutils/efetch/Csc.hpp>
#include <objtools/eutils/efetch/Csch.hpp>
#include <objtools/eutils/efetch/Csymbol.hpp>
#include <objtools/eutils/efetch/Csymbol_content.hpp>
#include <objtools/eutils/efetch/Curl.hpp>
#include <objtools/eutils/efetch/DataBank.hpp>
#include <objtools/eutils/efetch/DataBankList.hpp>
#include <objtools/eutils/efetch/DataBankName.hpp>
#include <objtools/eutils/efetch/DateCompleted.hpp>
#include <objtools/eutils/efetch/DateRevised.hpp>
#include <objtools/eutils/efetch/Day.hpp>
#include <objtools/eutils/efetch/Declare.hpp>
#include <objtools/eutils/efetch/Degree.hpp>
#include <objtools/eutils/efetch/DeleteCitation.hpp>
#include <objtools/eutils/efetch/DeleteDocument.hpp>
#include <objtools/eutils/efetch/DescriptorName.hpp>
#include <objtools/eutils/efetch/Determinant.hpp>
#include <objtools/eutils/efetch/Diff.hpp>
#include <objtools/eutils/efetch/DispFormula.hpp>
#include <objtools/eutils/efetch/Divergence.hpp>
#include <objtools/eutils/efetch/Divide.hpp>
#include <objtools/eutils/efetch/Domain.hpp>
#include <objtools/eutils/efetch/DomainQ.hpp>
#include <objtools/eutils/efetch/Domainofapplication.hpp>
#include <objtools/eutils/efetch/ELocationID.hpp>
#include <objtools/eutils/efetch/Edition.hpp>
#include <objtools/eutils/efetch/Emptyset.hpp>
#include <objtools/eutils/efetch/EndPage.hpp>
#include <objtools/eutils/efetch/EndingDate.hpp>
#include <objtools/eutils/efetch/Eq.hpp>
#include <objtools/eutils/efetch/Equivalent.hpp>
#include <objtools/eutils/efetch/Eulergamma.hpp>
#include <objtools/eutils/efetch/Exists.hpp>
#include <objtools/eutils/efetch/Exp.hpp>
#include <objtools/eutils/efetch/Exponentiale.hpp>
#include <objtools/eutils/efetch/Factorial.hpp>
#include <objtools/eutils/efetch/Factorof.hpp>
#include <objtools/eutils/efetch/False.hpp>
#include <objtools/eutils/efetch/Floor.hpp>
#include <objtools/eutils/efetch/Fn.hpp>
#include <objtools/eutils/efetch/Forall.hpp>
#include <objtools/eutils/efetch/ForeName.hpp>
#include <objtools/eutils/efetch/Gcd.hpp>
#include <objtools/eutils/efetch/GeneSymbol.hpp>
#include <objtools/eutils/efetch/GeneSymbolList.hpp>
#include <objtools/eutils/efetch/GeneralNote.hpp>
#include <objtools/eutils/efetch/Geq.hpp>
#include <objtools/eutils/efetch/Grad.hpp>
#include <objtools/eutils/efetch/Grant.hpp>
#include <objtools/eutils/efetch/GrantID.hpp>
#include <objtools/eutils/efetch/GrantList.hpp>
#include <objtools/eutils/efetch/Gt.hpp>
#include <objtools/eutils/efetch/History.hpp>
#include <objtools/eutils/efetch/Hour.hpp>
#include <objtools/eutils/efetch/I.hpp>
#include <objtools/eutils/efetch/ISOAbbreviation.hpp>
#include <objtools/eutils/efetch/ISSN.hpp>
#include <objtools/eutils/efetch/ISSNLinking.hpp>
#include <objtools/eutils/efetch/Ident.hpp>
#include <objtools/eutils/efetch/Identifier.hpp>
#include <objtools/eutils/efetch/Image.hpp>
#include <objtools/eutils/efetch/Imaginary.hpp>
#include <objtools/eutils/efetch/Imaginaryi.hpp>
#include <objtools/eutils/efetch/ImpliedMrow.hpp>
#include <objtools/eutils/efetch/Implies.hpp>
#include <objtools/eutils/efetch/In.hpp>
#include <objtools/eutils/efetch/Infinity.hpp>
#include <objtools/eutils/efetch/Initials.hpp>
#include <objtools/eutils/efetch/Int.hpp>
#include <objtools/eutils/efetch/Integers.hpp>
#include <objtools/eutils/efetch/Intersect.hpp>
#include <objtools/eutils/efetch/Interval.hpp>
#include <objtools/eutils/efetch/Inverse.hpp>
#include <objtools/eutils/efetch/Investigator.hpp>
#include <objtools/eutils/efetch/InvestigatorList.hpp>
#include <objtools/eutils/efetch/Isbn.hpp>
#include <objtools/eutils/efetch/Issue.hpp>
#include <objtools/eutils/efetch/Item.hpp>
#include <objtools/eutils/efetch/ItemList.hpp>
#include <objtools/eutils/efetch/Journal.hpp>
#include <objtools/eutils/efetch/JournalIssue.hpp>
#include <objtools/eutils/efetch/Keyword.hpp>
#include <objtools/eutils/efetch/KeywordList.hpp>
#include <objtools/eutils/efetch/Lambda.hpp>
#include <objtools/eutils/efetch/Language.hpp>
#include <objtools/eutils/efetch/Laplacian.hpp>
#include <objtools/eutils/efetch/LastName.hpp>
#include <objtools/eutils/efetch/Lcm.hpp>
#include <objtools/eutils/efetch/Leq.hpp>
#include <objtools/eutils/efetch/Limit.hpp>
#include <objtools/eutils/efetch/List.hpp>
#include <objtools/eutils/efetch/Ln.hpp>
#include <objtools/eutils/efetch/LocationLabel.hpp>
#include <objtools/eutils/efetch/Log.hpp>
#include <objtools/eutils/efetch/Logbase.hpp>
#include <objtools/eutils/efetch/Lowlimit.hpp>
#include <objtools/eutils/efetch/Lt.hpp>
#include <objtools/eutils/efetch/Maction.hpp>
#include <objtools/eutils/efetch/Maligngroup.hpp>
#include <objtools/eutils/efetch/Malignmark.hpp>
#include <objtools/eutils/efetch/Math.hpp>
#include <objtools/eutils/efetch/MathExpression.hpp>
#include <objtools/eutils/efetch/Matrix.hpp>
#include <objtools/eutils/efetch/Matrixrow.hpp>
#include <objtools/eutils/efetch/Max.hpp>
#include <objtools/eutils/efetch/Mean.hpp>
#include <objtools/eutils/efetch/Median.hpp>
#include <objtools/eutils/efetch/Medium.hpp>
#include <objtools/eutils/efetch/MedlineCitation.hpp>
#include <objtools/eutils/efetch/MedlineDate.hpp>
#include <objtools/eutils/efetch/MedlineJournalInfo.hpp>
#include <objtools/eutils/efetch/MedlinePgn.hpp>
#include <objtools/eutils/efetch/MedlineTA.hpp>
#include <objtools/eutils/efetch/Menclose.hpp>
#include <objtools/eutils/efetch/Merror.hpp>
#include <objtools/eutils/efetch/MeshHeading.hpp>
#include <objtools/eutils/efetch/MeshHeadingList.hpp>
#include <objtools/eutils/efetch/Mfenced.hpp>
#include <objtools/eutils/efetch/Mfrac.hpp>
#include <objtools/eutils/efetch/Mglyph.hpp>
#include <objtools/eutils/efetch/Mi.hpp>
#include <objtools/eutils/efetch/Min.hpp>
#include <objtools/eutils/efetch/Minus.hpp>
#include <objtools/eutils/efetch/Minute.hpp>
#include <objtools/eutils/efetch/Mlabeledtr.hpp>
#include <objtools/eutils/efetch/Mlongdiv.hpp>
#include <objtools/eutils/efetch/Mmultiscripts.hpp>
#include <objtools/eutils/efetch/Mn.hpp>
#include <objtools/eutils/efetch/Mo.hpp>
#include <objtools/eutils/efetch/Mode.hpp>
#include <objtools/eutils/efetch/Moment.hpp>
#include <objtools/eutils/efetch/Momentabout.hpp>
#include <objtools/eutils/efetch/Month.hpp>
#include <objtools/eutils/efetch/Mover.hpp>
#include <objtools/eutils/efetch/Mpadded.hpp>
#include <objtools/eutils/efetch/Mphantom.hpp>
#include <objtools/eutils/efetch/Mprescripts.hpp>
#include <objtools/eutils/efetch/Mroot.hpp>
#include <objtools/eutils/efetch/Mrow.hpp>
#include <objtools/eutils/efetch/Ms.hpp>
#include <objtools/eutils/efetch/Mscarries.hpp>
#include <objtools/eutils/efetch/Mscarry.hpp>
#include <objtools/eutils/efetch/Msgroup.hpp>
#include <objtools/eutils/efetch/Msline.hpp>
#include <objtools/eutils/efetch/Mspace.hpp>
#include <objtools/eutils/efetch/Msqrt.hpp>
#include <objtools/eutils/efetch/Msrow.hpp>
#include <objtools/eutils/efetch/MsrowExpression.hpp>
#include <objtools/eutils/efetch/Mstack.hpp>
#include <objtools/eutils/efetch/MstackExpression.hpp>
#include <objtools/eutils/efetch/Mstyle.hpp>
#include <objtools/eutils/efetch/Msub.hpp>
#include <objtools/eutils/efetch/Msubsup.hpp>
#include <objtools/eutils/efetch/Msup.hpp>
#include <objtools/eutils/efetch/Mtable.hpp>
#include <objtools/eutils/efetch/Mtd.hpp>
#include <objtools/eutils/efetch/Mtext.hpp>
#include <objtools/eutils/efetch/Mtr.hpp>
#include <objtools/eutils/efetch/MultiScriptExpression.hpp>
#include <objtools/eutils/efetch/Munder.hpp>
#include <objtools/eutils/efetch/Munderover.hpp>
#include <objtools/eutils/efetch/NameOfSubstance.hpp>
#include <objtools/eutils/efetch/Naturalnumbers.hpp>
#include <objtools/eutils/efetch/Neq.hpp>
#include <objtools/eutils/efetch/NlmUniqueID.hpp>
#include <objtools/eutils/efetch/None.hpp>
#include <objtools/eutils/efetch/Not.hpp>
#include <objtools/eutils/efetch/Notanumber.hpp>
#include <objtools/eutils/efetch/Note.hpp>
#include <objtools/eutils/efetch/Notin.hpp>
#include <objtools/eutils/efetch/Notprsubset.hpp>
#include <objtools/eutils/efetch/Notsubset.hpp>
#include <objtools/eutils/efetch/NumberOfReferences.hpp>
#include <objtools/eutils/efetch/Object.hpp>
#include <objtools/eutils/efetch/ObjectList.hpp>
#include <objtools/eutils/efetch/Or.hpp>
#include <objtools/eutils/efetch/OtherAbstract.hpp>
#include <objtools/eutils/efetch/OtherID.hpp>
#include <objtools/eutils/efetch/Otherwise.hpp>
#include <objtools/eutils/efetch/Outerproduct.hpp>
#include <objtools/eutils/efetch/PMID.hpp>
#include <objtools/eutils/efetch/Pagination.hpp>
#include <objtools/eutils/efetch/Param.hpp>
#include <objtools/eutils/efetch/Partialdiff.hpp>
#include <objtools/eutils/efetch/PersonalNameSubject.hpp>
#include <objtools/eutils/efetch/PersonalNameSubjectList.hpp>
#include <objtools/eutils/efetch/Pi.hpp>
#include <objtools/eutils/efetch/Piece.hpp>
#include <objtools/eutils/efetch/Piecewise.hpp>
#include <objtools/eutils/efetch/Plus.hpp>
#include <objtools/eutils/efetch/Power.hpp>
#include <objtools/eutils/efetch/Primes.hpp>
#include <objtools/eutils/efetch/Product.hpp>
#include <objtools/eutils/efetch/Prsubset.hpp>
#include <objtools/eutils/efetch/PubDate.hpp>
#include <objtools/eutils/efetch/PubMedPubDate.hpp>
#include <objtools/eutils/efetch/PublicationStatus.hpp>
#include <objtools/eutils/efetch/PublicationType.hpp>
#include <objtools/eutils/efetch/PublicationTypeList.hpp>
#include <objtools/eutils/efetch/Publisher.hpp>
#include <objtools/eutils/efetch/PublisherLocation.hpp>
#include <objtools/eutils/efetch/PublisherName.hpp>
#include <objtools/eutils/efetch/PubmedArticle.hpp>
#include <objtools/eutils/efetch/PubmedArticleSet.hpp>
#include <objtools/eutils/efetch/PubmedBookArticle.hpp>
#include <objtools/eutils/efetch/PubmedBookArticleSet.hpp>
#include <objtools/eutils/efetch/PubmedBookData.hpp>
#include <objtools/eutils/efetch/PubmedData.hpp>
#include <objtools/eutils/efetch/QualifierName.hpp>
#include <objtools/eutils/efetch/Quotient.hpp>
#include <objtools/eutils/efetch/Rationals.hpp>
#include <objtools/eutils/efetch/Real.hpp>
#include <objtools/eutils/efetch/Reals.hpp>
#include <objtools/eutils/efetch/RefSource.hpp>
#include <objtools/eutils/efetch/Reference.hpp>
#include <objtools/eutils/efetch/ReferenceList.hpp>
#include <objtools/eutils/efetch/RegistryNumber.hpp>
#include <objtools/eutils/efetch/Reln.hpp>
#include <objtools/eutils/efetch/Rem.hpp>
#include <objtools/eutils/efetch/ReportNumber.hpp>
#include <objtools/eutils/efetch/Root.hpp>
#include <objtools/eutils/efetch/Scalarproduct.hpp>
#include <objtools/eutils/efetch/Sdev.hpp>
#include <objtools/eutils/efetch/Season.hpp>
#include <objtools/eutils/efetch/Sec.hpp>
#include <objtools/eutils/efetch/Sech.hpp>
#include <objtools/eutils/efetch/Second.hpp>
#include <objtools/eutils/efetch/Section.hpp>
#include <objtools/eutils/efetch/SectionTitle.hpp>
#include <objtools/eutils/efetch/Sections.hpp>
#include <objtools/eutils/efetch/Selector.hpp>
#include <objtools/eutils/efetch/Semantics.hpp>
#include <objtools/eutils/efetch/Sep.hpp>
#include <objtools/eutils/efetch/Set.hpp>
#include <objtools/eutils/efetch/Setdiff.hpp>
#include <objtools/eutils/efetch/Share.hpp>
#include <objtools/eutils/efetch/Sin.hpp>
#include <objtools/eutils/efetch/Sinh.hpp>
#include <objtools/eutils/efetch/SpaceFlightMission.hpp>
#include <objtools/eutils/efetch/StartPage.hpp>
#include <objtools/eutils/efetch/Sub.hpp>
#include <objtools/eutils/efetch/Subset.hpp>
#include <objtools/eutils/efetch/Suffix.hpp>
#include <objtools/eutils/efetch/Sum.hpp>
#include <objtools/eutils/efetch/Sup.hpp>
#include <objtools/eutils/efetch/SupplMeshList.hpp>
#include <objtools/eutils/efetch/SupplMeshName.hpp>
#include <objtools/eutils/efetch/TableCellExpression.hpp>
#include <objtools/eutils/efetch/TableRowExpression.hpp>
#include <objtools/eutils/efetch/Tan.hpp>
#include <objtools/eutils/efetch/Tanh.hpp>
#include <objtools/eutils/efetch/Tendsto.hpp>
#include <objtools/eutils/efetch/Text.hpp>
#include <objtools/eutils/efetch/Times.hpp>
#include <objtools/eutils/efetch/Title.hpp>
#include <objtools/eutils/efetch/Token_content.hpp>
#include <objtools/eutils/efetch/Transpose.hpp>
#include <objtools/eutils/efetch/True.hpp>
#include <objtools/eutils/efetch/U.hpp>
#include <objtools/eutils/efetch/URL.hpp>
#include <objtools/eutils/efetch/Union.hpp>
#include <objtools/eutils/efetch/Uplimit.hpp>
#include <objtools/eutils/efetch/Variance.hpp>
#include <objtools/eutils/efetch/Vector.hpp>
#include <objtools/eutils/efetch/Vectorproduct.hpp>
#include <objtools/eutils/efetch/VernacularTitle.hpp>
#include <objtools/eutils/efetch/Volume.hpp>
#include <objtools/eutils/efetch/VolumeTitle.hpp>
#include <objtools/eutils/efetch/Xor.hpp>
#include <objtools/eutils/efetch/Year.hpp>
#include <objtools/eutils/efetch/efetch_module.hpp>
