/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file Version_.hpp
/// Data storage class.
///
/// This file was generated by application DATATOOL
/// using the following specifications:
/// 'soap_dataobj.xsd'.
///
/// ATTENTION:
///   Don't edit or commit this file into CVS as this file will
///   be overridden (by DATATOOL) without warning!

#ifndef SAMPLE_APP_SOAP_VERSION_BASE_HPP
#define SAMPLE_APP_SOAP_VERSION_BASE_HPP

// standard includes
#include <serial/serialbase.hpp>

// generated includes
#include <string>

BEGIN_NCBI_SCOPE

#ifndef BEGIN_objects_SCOPE
#  define BEGIN_objects_SCOPE BEGIN_SCOPE(objects)
#  define END_objects_SCOPE END_SCOPE(objects)
#endif
BEGIN_objects_SCOPE // namespace ncbi::objects::


// generated classes

/////////////////////////////////////////////////////////////////////////////
class CSampleVersion_Base : public CSerialObject
{
    typedef CSerialObject Tparent;
public:
    // constructor
    CSampleVersion_Base(void);
    // destructor
    virtual ~CSampleVersion_Base(void);

    // type info
    DECLARE_INTERNAL_TYPE_INFO();

    // types
    typedef string TClientID;

    // member index
    enum class E_memberIndex {
        e__allMandatory = 0,
        e_ClientID
    };
    typedef Tparent::CMemberIndex<E_memberIndex, 2> TmemberIndex;

    // getters
    // setters

    /// mandatory
    /// typedef string TClientID
    ///  Check whether the ClientID data member has been assigned a value.
    bool IsSetClientID(void) const;
    /// Check whether it is safe or not to call GetClientID method.
    bool CanGetClientID(void) const;
    void ResetClientID(void);
    const TClientID& GetClientID(void) const;
    void SetClientID(const TClientID& value);
    void SetClientID(TClientID&& value);
    TClientID& SetClientID(void);

    /// Reset the whole object
    virtual void Reset(void);


private:
    // Prohibit copy constructor and assignment operator
    CSampleVersion_Base(const CSampleVersion_Base&);
    CSampleVersion_Base& operator=(const CSampleVersion_Base&);

    // data
    Uint4 m_set_State[1];
    string m_ClientID;
};






///////////////////////////////////////////////////////////
///////////////////// inline methods //////////////////////
///////////////////////////////////////////////////////////
inline
bool CSampleVersion_Base::IsSetClientID(void) const
{
    return ((m_set_State[0] & 0x3) != 0);
}

inline
bool CSampleVersion_Base::CanGetClientID(void) const
{
    return IsSetClientID();
}

inline
const CSampleVersion_Base::TClientID& CSampleVersion_Base::GetClientID(void) const
{
    if (!CanGetClientID()) {
        ThrowUnassigned(0);
    }
    return m_ClientID;
}

inline
void CSampleVersion_Base::SetClientID(const CSampleVersion_Base::TClientID& value)
{
    m_ClientID = value;
    m_set_State[0] |= 0x3;
}

inline
void CSampleVersion_Base::SetClientID(CSampleVersion_Base::TClientID&& value)
{
    m_ClientID = std::forward<CSampleVersion_Base::TClientID>(value);
    m_set_State[0] |= 0x3;
}

inline
CSampleVersion_Base::TClientID& CSampleVersion_Base::SetClientID(void)
{
#ifdef _DEBUG
    if (!IsSetClientID()) {
        m_ClientID = UnassignedString();
    }
#endif
    m_set_State[0] |= 0x1;
    return m_ClientID;
}

///////////////////////////////////////////////////////////
////////////////// end of inline methods //////////////////
///////////////////////////////////////////////////////////





END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE


#endif // SAMPLE_APP_SOAP_VERSION_BASE_HPP
