/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file JsonValue_.hpp
/// Data storage class.
///
/// This file was generated by application DATATOOL
/// using the following specifications:
/// 'jsd_sample_lib.jsd'.
///
/// ATTENTION:
///   Don't edit or commit this file into CVS as this file will
///   be overridden (by DATATOOL) without warning!

#ifndef SAMPLE_LIB_JSD_JSONVALUE_BASE_HPP
#define SAMPLE_LIB_JSD_JSONVALUE_BASE_HPP

// standard includes
#include <serial/serialbase.hpp>
BEGIN_NCBI_SCOPE

#ifndef BEGIN_objects_SCOPE
#  define BEGIN_objects_SCOPE BEGIN_SCOPE(objects)
#  define END_objects_SCOPE END_SCOPE(objects)
#endif
BEGIN_objects_SCOPE // namespace ncbi::objects::


// forward declarations
class CData_set_id;


// generated classes

/////////////////////////////////////////////////////////////////////////////
class CJsonValue_Base : public CSerialObject
{
    typedef CSerialObject Tparent;
public:
    // constructor
    CJsonValue_Base(void);
    // destructor
    virtual ~CJsonValue_Base(void);

    // type info
    DECLARE_INTERNAL_TYPE_INFO();

    // types
    typedef CData_set_id TData_set_id;

    // member index
    enum class E_memberIndex {
        e__allMandatory = 0,
        e_Data_set_id
    };
    typedef Tparent::CMemberIndex<E_memberIndex, 2> TmemberIndex;

    // getters
    // setters

    /// optional
    /// typedef CData_set_id TData_set_id
    ///  Check whether the Data_set_id data member has been assigned a value.
    bool IsSetData_set_id(void) const;
    /// Check whether it is safe or not to call GetData_set_id method.
    bool CanGetData_set_id(void) const;
    void ResetData_set_id(void);
    const TData_set_id& GetData_set_id(void) const;
    void SetData_set_id(TData_set_id& value);
    TData_set_id& SetData_set_id(void);

    /// Reset the whole object
    virtual void Reset(void);


private:
    // Prohibit copy constructor and assignment operator
    CJsonValue_Base(const CJsonValue_Base&);
    CJsonValue_Base& operator=(const CJsonValue_Base&);

    // data
    Uint4 m_set_State[1];
    CRef< TData_set_id > m_Data_set_id;
};






///////////////////////////////////////////////////////////
///////////////////// inline methods //////////////////////
///////////////////////////////////////////////////////////
inline
bool CJsonValue_Base::IsSetData_set_id(void) const
{
    return m_Data_set_id.NotEmpty();
}

inline
bool CJsonValue_Base::CanGetData_set_id(void) const
{
    return IsSetData_set_id();
}

inline
const CJsonValue_Base::TData_set_id& CJsonValue_Base::GetData_set_id(void) const
{
    if (!CanGetData_set_id()) {
        ThrowUnassigned(0);
    }
    return (*m_Data_set_id);
}

///////////////////////////////////////////////////////////
////////////////// end of inline methods //////////////////
///////////////////////////////////////////////////////////





END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE


#endif // SAMPLE_LIB_JSD_JSONVALUE_BASE_HPP
